import java.io.*;
import java.util.*;

public class B {
	static int cons = 1000000000;
	public void solve() throws IOException {
		long a = nextLong();
		long b = nextLong();
		long k = nextLong();
		long l = 0;
		long r = 1000000000*1000000000;
		while (r - l > 1) {
			long mid = (r + l) / 2;
			if (mid * mid * mid >= a) {
				r = mid;
			} else {
				l = mid;
			}
		}
		long sqrA = (long) Math.sqrt(a);
		if (sqrA * sqrA < a) {
			sqrA++;
		}
		long sqrB = (long) Math.sqrt(b);
		long fir = r;
		long sum = 0;
		long c = 0;
		long d = (long) Math.sqrt(fir * fir * fir);
		if(d*d != fir*fir*fir) {
			d++;
		}
		while (fir * fir * fir <= b) {
			l = -1;
			r = cons;
			long cube = fir * fir * fir;
			while (r - l > 1) {
				long mid = (r + l) / 2;
				long sqr = 0;
				if (mid == 1) {
					sqr = c * c + 2 * c + 1;
				} else {
					sqr = c * c + (2 * c + mid) * mid;
				}
				if (sqr > cube) {
					r = mid;
				} else {
					if (cube - sqr <= k) {
						r = mid;
					} else {
						l = mid;
					}
				}
			}
			c += r;
			if (cube - c * c <= k) {
				sum += Math.sqrt(cube) - Math.max(c, sqrA) + 1;
			}
			l = 0;
			r = cons;
			while (r - l > 1) {
				long mid = (r + l) / 2;
				long sqr = 0;
				if (mid == 1) {
					sqr = d * d + 2 * d + 1;
				} else {
					sqr = d * d + (2 * d + mid) * mid;
				}
				if (sqr - cube > k) {
					r = mid;
				} else {
					l = mid;
				}
			}
			d += l;
			if (d * d - cube <= k) {
				sum += Math.min(d, sqrB) - (long) Math.sqrt(cube);
				// sum += Math.sqrt(cube)-Math.max(c, sqrA)+1;
			}
			long sqr = (long) Math.sqrt(cube);
			fir++;
		}
		/*
		 * while(fir*fir*fir <= b) { long cube = fir*fir*fir; long sqrt = (long)
		 * Math.sqrt(cube); long sqr = sqrt*sqrt; long s = Math.min(cube-a, k); long t =
		 * cube-sqr; long l1 = 1; long r1 = 5; while(r1-l1 > 1) { long mid = (l1+r1)/2;
		 * if(2*sqrt-2*mid+1 < 0) { r1 = mid; continue; } if((2*sqrt-mid)*mid <= s-t) {
		 * l1 = mid; } else { r1 = mid; } } if(l1 == 1 && sqr >= a && t <= k) { } else {
		 * l--; } sum += l1; sqrt++; sqr = sqrt*sqrt; s = Math.min(b-cube, k); t =
		 * sqr-cube; l1 = 1; r1 = 5; while(r1-l1 > 0) { long mid = (l1+r1)/2;
		 * if(2*sqrt-2*mid+1 < 0) { r1 = mid; continue; } if((2*sqrt-mid)*mid <= s-t) {
		 * l1 = mid; } else { r1 = mid; } } sum += l1; }
		 */
		out.println(sum);
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new B().run();
	}

}
