import java.io.*;
import java.util.*;

public class C2 {
	static int cons = 1000000000;
	static ArrayList<Integer> []gr;
	static int max1, max2;
	public void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		int []p = new int [n+1];
		p[1] = 0;
		gr = new ArrayList [n+1];
		for(int i = 1;i<=n;i++) {
			gr[i] = new ArrayList();
		}
		for(int i = 2;i<=n;i++) {
			p[i] = nextInt();
			gr[p[i]].add(i);
		}
		max1 = Integer.MIN_VALUE;
		max2 = Integer.MIN_VALUE;
		findMax(1);
		out.println(max1+max2+2*(m-1)*(1+max1)+1);
	}

	private int findMax(int i) {
		if(i != 1) {
			int maxNow = 1;
			for(int j = 0;j<gr[i].size();j++) {
				maxNow = Math.max(maxNow, 1+findMax(gr[i].get(j)));
			}
			return maxNow;
		} else {
			for(int j = 0;j<gr[i].size();j++) {
				int w = findMax(gr[i].get(j));
				if(w > max1) {
					max2 = max1;
					max1 = w;
				} else {
					if(w > max2) {
						max2 = w;
					}
				}
			}
			return 0;
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new C2().run();
	}

}
