import java.io.*;
import java.util.*;

public class C2 {
	static int cons = -10000000;
	static ArrayList<Integer> []gr;
	static int max1, max2;
	public void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		int []p = new int [n+1];
		p[1] = 0;
		gr = new ArrayList [n+1];
		for(int i = 1;i<=n;i++) {
			gr[i] = new ArrayList();
		}
		for(int i = 2;i<=n;i++) {
			p[i] = nextInt();
			gr[p[i]].add(i);
		}
		max1 = cons;
		max2 = cons;
		findMax(1);
		if(max2 == Integer.MIN_VALUE) {
			out.println(m*max1+1);
		} else {
			out.println(max1+max2-1);
			//out.println(max1+max2+2*(m-1)*(1+max1)+1);
		}
	}

	private int findMax(int i) {
		int maxNow1 = cons;
		int maxNow2 = cons;
			for(int j = 0;j<gr[i].size();j++) {
				int w = findMax(gr[i].get(j))+1;
				if(w > maxNow1) {
					maxNow2 = maxNow1;
					maxNow1 = w;
				} else {
					if(w > maxNow2) {
						maxNow2 = w;
					}
				}
			}
		if(maxNow1+maxNow2 > max1+max2) {
			max1 = maxNow1;
			max2 = maxNow2;
		}
		return Math.max(1, maxNow1);
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new C2().run();
	}

}
