import java.io.*;
import java.util.*;

public class B2 {
	static int cons = 1000000000;
	static long k, s;
	public void solve() throws IOException {
		k = nextInt();
		s = nextLong();
		long l = 0;
		long r = 1000000;
		while(r-l > 1) {
			long mid = (l+r)/2;
			if(can(mid)) {
				r = mid;
			} else {
				l = mid;
			}
		}
		long t = 0;
		for(int i = 1;i<=r;i++) {
			long sMin = 0;
			long sMax = 0;
			if(i == 1) {
				sMin = k+1;
				sMax = k+r;
			} else {
				sMin = (k+k+i+1)*i/2;
				sMax = (k+r+k+r-i+1)*i/2;
			}
			if(s >= sMin && s <= sMax) {
				t = i;
			}
			if(s < sMin) {
				break;
			}
		}
		out.println(r-t+k);
	}

	private boolean can(long n) {
		int l = 0;
		int r = (int) n+1;
		while(r-l > 1) {
			int mid = (r+l)/2;
			long sMin = 0;
			long sMax = 0;
			if(mid == 1) {
				sMin = k+1;
				sMax = k+n;
			} else {
				sMin = (k+k+mid+1)*mid/2;
				sMax = (k+n+k+n-mid+1)*mid/2;
			}
			if(s <= sMax && s >= sMin) {
				return true;
			}
			if(s > sMax) {
				l = mid;
			} else {
				r = mid;
			}
		}
		return false;
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new B2().run();
	}

}
