import java.io.*;
import java.util.*;

public class D2 {
	class Pair {
		int l;
		int r;

		public Pair(int l, int r) {
			this.l = l;
			this.r = r;
		}
	}

	static int cons = 100000;
	static ArrayList<Pair>[] ar;
	static int sumAll = 1;
	public void solve() throws IOException {
		int k = nextInt();
		int n = nextInt();
		int m = nextInt();
		ar = new ArrayList [m+1];
		for(int i = 1;i<=m;i++) {
			ar[i] = new ArrayList();
		}
		int []sum = new int [m+1];
		int max = Integer.MIN_VALUE;
		int maxInd = Integer.MIN_VALUE;
		int now = 1;
		for(int i = 1;i<=n;i++) {
			int size = nextInt();
			int val = nextInt();
			sum[val] += size;
			if(sum[val] > max) {
				max = sum[val];
				maxInd = val;
			}
			ar[val].add(new Pair(now, now+size-1));
			now += size;
		}
		for(int i = 1;i<=m;i++) {
			if(ar[i].size() == 0 || i == maxInd) {
				continue;
			}
			int l = 1;
			int r = 1;
			int left = ar[i].get(0).l;
			while(l <= left) {
				l *= 2;
			}
			l /= 2;
			int right = ar[i].get(ar[i].size()-1).r;
			while(r < right) {
				r *= 2;
			}
			sumAll += findSum(i, 0, ar[i].size()-1, l, r, 0);
		}
		out.println(sumAll);
	}

	private int findSum(int i, int lInd, int rInd, int l, int r, int type) {
		if(lInd == -1 || lInd == ar[i].size()) {
			return 0;
		}
		if(l == r) {
			return 1;
		}
		int mid = (l+r)/2;
		int l1 = lInd;
		int r1 = rInd;
		while(r1-l1 > 1) {
			int mid1 = (r1+l1)/2;
			if(ar[i].get(mid1).l >= mid) {
				r1 = mid1;
			} else {
				l1 = mid1;
			}
		}
		int sum1 = 0;
		if(ar[i].get(l1).l > mid) {
			sum1 = findSum(i, l1, rInd, mid+1, r, 0);
		} else {
			if(ar[i].get(l1).r <= mid) {
				sum1 = findSum(i, lInd, l1, l, mid, 0);
			} else {
				sum1 = findSum(i, lInd, l1, l, mid, 0)+findSum(i, l1, rInd, mid+1, r, 0);
			}
		}
		return sum1;
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new D2().run();
	}

}
